1 #!/bin/sh -- # no runable script, just for vi
3 # we all like colorful messages
4 CERROR
="\e[1;31m" # red
5 CWARNING
="\e[1;33m" # yellow
6 CMSG
="\e[1;32m" # green
7 CINFO
="\e[1;96m" # light blue
8 CDEBUG
="\e[1;94m" # blue
9 CNORMAL
="\e[0;39m" # default system console color
10 CDONE
="\e[1;32m" # green
11 CPASS
="\e[1;32m" # green
12 CFAIL
="\e[1;31m" # red
13 CCMD
="\e[1;35m" # pink
15 msgdie
() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
16 msgwarn
() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
17 msgmsg
() { echo "${CMSG}$1${CNORMAL}" >&2; }
18 msginfo
() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
19 msgdebug
() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
20 msgdone
() { echo "${CDONE}DONE${CNORMAL}" >&2; }
21 msgnwarn
() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
22 msgnmsg
() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
23 msgninfo
() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
24 msgndebug
() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
25 msgtest
() { echo -n "${CINFO}$1 ${CCMD}$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} …${CNORMAL} " >&2; }
26 msgpass
() { echo "${CPASS}PASS${CNORMAL}" >&2; }
27 msgskip
() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
28 msgfail
() { echo "${CFAIL}FAIL${CNORMAL}" >&2; }
30 # enable / disable Debugging
31 MSGLEVEL
=${MSGLEVEL:-3}
32 if [ $MSGLEVEL -le 0 ]; then
35 if [ $MSGLEVEL -le 1 ]; then
39 if [ $MSGLEVEL -le 2 ]; then
43 if [ $MSGLEVEL -le 3 ]; then
47 if [ $MSGLEVEL -le 4 ]; then
52 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
53 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
54 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
55 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
56 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
59 echo "${CDONE}DONE${CNORMAL}" >&2;
64 msgdebug
"Executing: ${CCMD}$*${CDEBUG} "
65 if [ -f .
/aptconfig.conf
]; then
66 APT_CONFIG
=aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
68 LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
71 aptconfig
() { runapt apt
-config $
*; }
72 aptcache
() { runapt apt
-cache $
*; }
73 aptget
() { runapt apt
-get $
*; }
74 aptftparchive
() { runapt apt
-ftparchive $
*; }
76 $(which dpkg) --root=${TMPWORKINGDIRECTORY}/rootdir
--force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir
/var
/log
/dpkg.log $
*
80 TMPWORKINGDIRECTORY
=$(mktemp -d)
81 local TESTDIR
=$(readlink -f $(dirname $0))
82 msgninfo
"Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
83 BUILDDIRECTORY
="${TESTDIR}/../../build/bin"
84 test -x "${BUILDDIRECTORY}/apt-get" || msgdie
"You need to build tree first"
85 local OLDWORKINGDIRECTORY
=$(pwd)
86 CURRENTTRAP
="cd /; rm -rf $TMPWORKINGDIRECTORY; cd $OLDWORKINGDIRECTORY"
87 trap "$CURRENTTRAP" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
88 cd $TMPWORKINGDIRECTORY
89 mkdir rootdir aptarchive keys
91 mkdir -p etc
/apt
/apt.conf.d etc
/apt
/sources.list.d etc
/apt
/trusted.gpg.d etc
/apt
/preferences.d
92 mkdir -p var
/cache var
/lib var
/log
93 mkdir -p var
/lib
/dpkg
/info var
/lib
/dpkg
/updates var
/lib
/dpkg
/triggers
94 local STATUSFILE
=$(echo "$(basename $0)" | sed 's/^test-/status-/')
95 if [ -f "${TESTDIR}/${STATUSFILE}" ]; then
96 cp "${TESTDIR}/${STATUSFILE}" var/lib/dpkg/status
98 touch var/lib/dpkg/status
100 touch var/lib/dpkg/available
102 ln -s ${BUILDDIRECTORY}/methods usr/lib/apt/methods
104 local PACKAGESFILE=$(echo "$(basename $0)" | sed 's/^test-/Packages-/')
105 if [ -f "${TESTDIR}/${PACKAGESFILE}" ]; then
106 cp "${TESTDIR}/${PACKAGESFILE}" aptarchive
/Packages
108 touch aptarchive
/Packages
110 cp $(find $TESTDIR -name '*.pub' -o -name '*.sec') keys
/
111 ln -s ${TMPWORKINGDIRECTORY}/keys
/joesixpack.pub rootdir
/etc
/apt
/trusted.gpg.d
/joesixpack.gpg
112 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
113 echo "Debug::NoLocking \"true\";" >> aptconfig.conf
114 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
115 echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
116 echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
117 echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
118 echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
119 echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
120 echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
125 configarchitecture
() {
126 local CONFFILE
=rootdir
/etc
/apt
/apt.conf.d
/01multiarch.conf
127 echo "APT::Architecture \"$1\";" > $CONFFILE
129 while [ -n "$1" ]; do
130 echo "APT::Architectures:: \"$1\";" >> $CONFFILE
135 setupsimplenativepackage
() {
139 local RELEASE
="${4:-unstable}"
140 local DEPENDENCIES
="$5"
141 local DESCRIPTION
="$6"
142 local SECTION
="${7:-others}"
144 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
147 DISTSECTION
="$(echo "$SECTION" | cut -d'/' -f 1)"
149 local BUILDDIR
=incoming
/${NAME}-${VERSION}
150 mkdir -p ${BUILDDIR}/debian
/source
152 echo "* most suckless software product ever" > FEATURES
153 test -e debian
/copyright
|| echo "Copyleft by Joe Sixpack $(date +%Y)" > debian
/copyright
154 test -e debian
/changelog
|| echo "$NAME ($VERSION) $RELEASE; urgency=low
158 -- Joe Sixpack <joe@example.org> $(date -R)" > debian
/changelog
159 test -e debian
/control
|| echo "Source: $NAME
162 Maintainer: Joe Sixpack <joe@example.org>
163 Build-Depends: debhelper (>= 7)
164 Standards-Version: 3.9.1
167 Architecture: $ARCH" > debian
/control
168 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian
/control
169 if [ -z "$DESCRIPTION" ]; then
170 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
171 If you find such a package installed on your system,
172 YOU did something horribly wrong! They are autogenerated
173 und used only by testcases for APT and surf no other propose…" >> debian
/control
175 echo "Description: $DESCRIPTION" >> debian
/control
177 test -e debian
/compat
|| echo "7" > debian
/compat
178 test -e debian
/source
/format
|| echo "3.0 (native)" > debian
/source
/format
179 test -e debian
/rules
|| cp /usr
/share
/doc
/debhelper
/examples
/rules.tiny debian
/rules
183 buildsimplenativepackage
() {
187 local RELEASE
="${4:-unstable}"
188 local DEPENDENCIES
="$5"
189 local DESCRIPTION
="$6"
190 local SECTION
="${7:-others}"
192 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
195 DISTSECTION
="$(echo "$SECTION" | cut -d'/' -f 1)"
197 setupsimplenativepackage
"$NAME" "$ARCH" "$VERSION" "$RELEASE" "$DEPENDENCIES" "$DESCRIPTION" "$SECTION"
198 buildpackage
"incoming/${NAME}-${VERSION}" "$RELEASE" "$DISTSECTION"
199 rm -rf "incoming/${NAME}-${VERSION}"
206 msgninfo
"Build package $(echo "$BUILDDIR" | grep -o '[^/]*$') for ${RELEASE} in ${SECTION}… "
208 if [ "$ARCH" = "all" ]; then
209 ARCH
="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
211 local BUILT
="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
212 local PKGS
="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
213 local SRCS
="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._-]*$')"
216 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming
/${RELEASE}.
${SECTION}.pkglist
219 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming
/${RELEASE}.
${SECTION}.srclist
225 if [ -d incoming
]; then
226 buildaptarchivefromincoming $
*
228 buildaptarchivefromfiles $
*
232 createaptftparchiveconfig
() {
233 local ARCHS
="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
234 if [ -z "$ARCHS" ]; then
235 # the pool is empty, so we will operate on faked packages - let us use the configured archs
236 ARCHS
="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
239 ArchiveDir "' >> ftparchive.conf
240 echo -n $(readlink -f .) >> ftparchive.conf
242 CacheDir "' >> ftparchive.conf
243 echo -n $(readlink -f ..) >> ftparchive.conf
245 FileListDir "' >> ftparchive.conf
246 echo -n $(readlink -f pool/) >> ftparchive.conf
250 Packages::Compress ". gzip bzip2 lzma";
251 Sources::Compress ". gzip bzip2 lzma";
252 Contents::Compress ". gzip bzip2 lzma";
256 SrcDirectory "pool/";
262 Label "apttestcases";
264 Description "repository with dummy packages";
265 Architectures "' >> ftparchive.conf
266 echo -n "$ARCHS" >> ftparchive.conf
270 };' >> ftparchive.conf
271 for DIST
in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
272 echo -n 'tree "dists/' >> ftparchive.conf
273 echo -n "$DIST" >> ftparchive.conf
275 Architectures "' >> ftparchive.conf
276 echo -n "$ARCHS" >> ftparchive.conf
278 FileList "' >> ftparchive.conf
279 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
281 SourceFileList "' >> ftparchive.conf
282 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
284 Sections "' >> ftparchive.conf
285 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
287 };' >> ftparchive.conf
291 buildaptftparchivedirectorystructure
() {
292 local DISTS
="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
293 for DIST
in $DISTS; do
294 local SECTIONS
="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
295 for SECTION
in $SECTIONS; do
296 local ARCHS
="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
297 for ARCH
in $ARCHS; do
298 mkdir -p dists
/${DIST}/${SECTION}/binary
-${ARCH}
300 mkdir -p dists
/${DIST}/${SECTION}/source
301 mkdir -p dists
/${DIST}/${SECTION}/i18n
306 buildaptarchivefromincoming
() {
307 msginfo
"Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
309 [ -e pool
] || ln -s ..
/incoming pool
310 [ -e ftparchive.conf
] || createaptftparchiveconfig
311 [ -e dists
] || buildaptftparchivedirectorystructure
312 msgninfo
"\tGenerate Packages, Sources and Contents files… "
313 aptftparchive
-qq generate ftparchive.conf
315 msgninfo
"\tGenerate Release files… "
316 for dir
in $(find ./dists -mindepth 1 -maxdepth 1 -type d); do
317 aptftparchive
-qq release
$dir -o APT
::FTPArchive
::Release
::Codename
="$(echo "$dir" | cut -d'/' -f 3)" | sed -e '/0 Release$/ d' > $dir/Release
# remove the self reference
323 buildaptarchivefromfiles
() {
324 msginfo
"Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
326 if [ -f Packages
]; then
327 msgninfo
"\tPackages file… "
328 cat Packages
| gzip > Packages.gz
329 cat Packages
| bzip2 > Packages.bz2
330 cat Packages
| lzma
> Packages.lzma
333 if [ -f Sources
]; then
334 msgninfo
"\tSources file… "
335 cat Sources
| gzip > Sources.gz
336 cat Sources
| bzip2 > Sources.bz2
337 cat Sources
| lzma
> Sources.lzma
340 msgninfo
"\tRelease file… "
341 aptftparchive
-qq release .
| sed -e '/0 Release$/ d' > Release
# remove the self reference
346 setupdistsaptarchive
() {
347 local APTARCHIVE
=$(readlink -f ./aptarchive)
348 rm -f root
/etc
/apt
/sources.list.d
/apt
-test-*-deb.list
349 rm -f root
/etc
/apt
/sources.list.d
/apt
-test-*-deb-src.list
350 for DISTS
in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
351 SECTIONS
=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
352 msgninfo
"\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
353 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-${DISTS}-deb.list
354 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-${DISTS}-deb-src.list
359 setupflataptarchive
() {
360 local APTARCHIVE
=$(readlink -f ./aptarchive)
361 if [ -f ${APTARCHIVE}/Packages
]; then
362 msgninfo
"\tadd deb sources.list line… "
363 echo "deb file://$APTARCHIVE /" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb.list
366 rm -f rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb.list
368 if [ -f ${APTARCHIVE}/Sources
]; then
369 msgninfo
"\tadd deb-src sources.list line… "
370 echo "deb-src file://$APTARCHIVE /" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb-src.list
373 rm -f rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb-src.list
379 if [ -e aptarchive
/dists
]; then
385 msgninfo
"\tSync APT's cache with the archive… "
391 local SIGNER
="${1:-Joe Sixpack}"
392 msgninfo
"\tSign archive with $SIGNER key… "
394 for KEY
in $(find keys/ -name '*.sec'); do
395 SECKEYS
="$SECKEYS --secret-keyring $KEY"
398 for KEY
in $(find keys/ -name '*.pub'); do
399 PUBKEYS
="$PUBKEYS --keyring $KEY"
401 for RELEASE
in $(find aptarchive/ -name Release); do
402 gpg
--yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" -abs -o ${RELEASE}.gpg
${RELEASE}
407 changetowebserver
() {
408 if which weborf
> /dev
/null
; then
409 weborf
-xb aptarchive
/ 2>&1 > /dev
/null
&
410 CURRENTTRAP
="kill $(ps | grep weborf | sed -e 's#^[ ]*##' | cut -d' ' -f 1); $CURRENTTRAP"
411 trap "$CURRENTTRAP" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
412 local APTARCHIVE
="file://$(readlink -f ./aptarchive)"
413 for LIST
in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
414 sed -i $LIST -e "s#$APTARCHIVE#http://localhost:8080/#"
422 local DIFFTEXT
="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
423 if [ -n "$DIFFTEXT" ]; then
435 msgtest
"Test for correctness of file" "$FILE"
437 echo -n "" | checkdiff
$FILE - && msgpass
|| msgfail
439 echo "$*" | checkdiff
$FILE - && msgpass
|| msgfail
444 local COMPAREFILE
=$(mktemp)
445 echo "$1" > $COMPAREFILE
447 msgtest
"Test for equality of" "$*"
448 $
* 2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
453 local COMPAREFILE1
=$(mktemp)
454 local COMPAREFILE2
=$(mktemp)
455 local COMPAREAGAINST
=$(mktemp)
456 echo "$1" > $COMPAREFILE1
457 echo "$2" > $COMPAREFILE2
459 msgtest
"Test for equality OR of" "$*"
460 $
* 2>&1 1> $COMPAREAGAINST
461 (checkdiff
$COMPAREFILE1 $COMPAREAGAINST 1> /dev
/null
||
462 checkdiff
$COMPAREFILE2 $COMPAREAGAINST 1> /dev
/null
) && msgpass
||
463 ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
464 "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
466 rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST
470 local VIRTUAL
="N: Can't select versions from package '$1' as it purely virtual"
473 while [ -n "$1" ]; do
475 N: Can't select versions from package '$1' as it purely virtual"
476 PACKAGE
="${PACKAGE} $1"
479 msgtest
"Test for virtual packages" "apt-cache show $PACKAGE"
481 N: No packages found"
482 local COMPAREFILE
=$(mktemp)
483 local ARCH
=$(dpkg-architecture -qDEB_HOST_ARCH_CPU)
484 eval `apt-config shell ARCH APT::Architecture`
485 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
486 aptcache show
-q=0 $PACKAGE 2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
491 msgtest
"Test for non-existent packages" "apt-cache show $*"
492 local SHOWPKG
="$(aptcache show $* 2>&1 | grep '^Package: ')"
493 if [ -n "$SHOWPKG" ]; then